#include <stdio.h>
#include <stdlib.h>
//#include <new.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "plugin_only_exec.h"

int shmkey;

void* operator new (int size)
{
   int     shmid;
   void*   shmaddr;
 
   printf("# New handler allocating %d.\n",size);
   
   shmid = shmget((key_t)shmkey,size,0750+IPC_CREAT);
   if(shmid == -1)
     return NULL;
   
   shmaddr  = (void*) shmat(shmid,NULL,0);
   if(shmaddr == (void*)-1)
     return NULL;

   return shmaddr;
}

extern void plugin_run ();

int plugin_main (int argc, char** argv)
{
   int shmid;
   
   if ((argc < 3) || (strcmp (argv[1], "-plugin") != 0)) {
      printf ("This is a plug-in.");
      printf("It can only be run by a application.\n");
      exit(127);
   }
   else {      
      printf("# Command line is %s %s %s\n",argv[0],argv[1],argv[2]);
      
      shmkey = atoi(argv[2]);
     
      printf("# Runing the plugin specific code.\n");
      plugin_run();
      
      //printf("Plugin Adress %x\n",(void*)(plugin))     
      printf("# Plugin exiting\n");
   }
}
